#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_ArenaTaskCFG.h"
std::auto_ptr<Fish_ArenaTaskCFG> Fish_ArenaTaskCFG::msSingleton(nullptr);

int Fish_ArenaTaskCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ArenaTaskCFGData* Fish_ArenaTaskCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_ArenaTaskCFGData>& Fish_ArenaTaskCFG::GetMapData()
{
	return mMapData;
}

void Fish_ArenaTaskCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_ArenaTaskCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ArenaTaskCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mGroup = element->IntAttribute("Group");
		data.mTaskDesc = element->Attribute("TaskDesc");
		data.mfishId = element->IntAttribute("fishId");
		data.mneedCount = element->IntAttribute("needCount");
		data.mType = element->IntAttribute("Type");
		data.mTaskReward = element->IntAttribute("TaskReward");
		data.mTaskRewardDesc1 = element->Attribute("TaskRewardDesc1");
		data.mTaskRewardDesc2 = element->Attribute("TaskRewardDesc2");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_ArenaTaskCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ArenaTaskCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_ArenaTaskCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_ArenaTaskCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_ArenaTaskCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Group", data.mGroup);
		LuaCfgHelper::readString(L, "TaskDesc", data.mTaskDesc);
		LuaCfgHelper::readInt(L, "fishId", data.mfishId);
		LuaCfgHelper::readInt(L, "needCount", data.mneedCount);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "TaskReward", data.mTaskReward);
		LuaCfgHelper::readString(L, "TaskRewardDesc1", data.mTaskRewardDesc1);
		LuaCfgHelper::readString(L, "TaskRewardDesc2", data.mTaskRewardDesc2);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_ArenaTaskCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ArenaTaskCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_ArenaTaskCFG* Fish_ArenaTaskCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ArenaTaskCFG());
	}
	return msSingleton.get();
}

void Fish_ArenaTaskCFG::Release()
{
	msSingleton.reset(nullptr);
}
